<template>
  <div class="contents">
    <div class="contents_wrap">
      <div class="top_wrap">
        <h3 class="title">알림톡 템플릿 관리</h3>
        <p class="breadcrumb">카카오 채널관리 &gt; 알림톡 템플릿 관리</p>
      </div>
      <div class="search_wrap">
        <div class="select_box id">
          <label for="stat" class="label">상태</label>
          <select name="" id="stat" v-model="searchType1" @keyup.enter="search">
            <option value="">전체</option>
            <option v-for="(option, i) in statType" v-bind:value="option.code" v-bind:key="i">
              {{ option.codeNm }}
            </option>
          </select>
        </div>
        <div class="select_box">
          <label for="searchType" class="label">상세검색</label>
          <select name="" id="searchType" v-model="searchType2" @keyup.enter="search">
            <option value="custNm" selected="selected">고객사명</option>
            <option value="bizNo">사업자번호</option>
            <option value="tmpltNm">템플릿명</option>
          </select>
        </div>
        <div class="input_box">
          <input
            class="search-box"
            type="text"
            id="id1"
            placeholder="검색어 입력"
            v-model.trim="grid.params.searchText1"
            @keyup.enter="search"
            maxlength="100"
          />
        </div>
        <button type="button" class="button grey" @click="search">조회</button>
      </div>
      <div class="info">
        <div class="count">
          총 <span>{{ totalItems.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',') }}</span
          >건
          <div class="select_box NumberSe">
            <select name="" id="perPage" v-model="perPageCnt" @change="changePerPage()">
              <option v-for="option in options" v-bind:value="option.value" v-bind:key="option.value">
                {{ option.text }}
              </option>
            </select>
          </div>
        </div>
      </div>
      <div class="table">
        <custom-grid
          ref="table"
          :totalItems="'totalItems'"
          :url="grid.url"
          :pagePerRows="grid.pagePerRows"
          :initialRequest="grid.initialRequest"
          :pagination="grid.pagination"
          :isCheckbox="grid.isCheckbox"
          :columns="grid.columns"
          :noDataStr="grid.noDataStr"
          :addCls="grid.addCls"
          :header="grid.headder"
        ></custom-grid>

        <common-modal ref="commmonModal"></common-modal>
      </div>
    </div>
  </div>
</template>

<script>
import customGrid from '@/components/CustomGrid';
import channelMgtApi from '../service/channelMgtApi';
import xlsx from '@/common/excel';
import moment from 'moment';
import commonModal from '@/components/modal/commonModal';
import api from '@/service/api';

export default {
  name: 'temltList',
  data() {
    return {
      row: {},
      authType: [],
      statType: [],
      cate2Code: '',
      totalItems: 0,
      pageType: 'CHANN',
      searchType1: '',
      searchType2: 'custNm',
      // 테이블 리스트 데이터
      perPageCnt: 50,
      options: [
        { text: '20', value: 20 },
        { text: '50', value: 50 },
        { text: '100', value: 100 },
      ],
      grid: {
        url: '/api/v1/bo/channelMgt/tmpltList',
        perPage: 20,
        pagination: true,
        isCheckbox: false,
        initialRequest: false,
        addCls: 'box_OFvis',

        header: [
          [
            { header: 'No', childNames: [] },
            { header: '고객사명', childNames: [] },
            { header: '사업자번호', childNames: [] },
            { header: '템플릿코드', childNames: [] },
            { header: '템플릿명', childNames: [] },
            { header: '템플릿 유형', childNames: [] },
            { header: '상태', childNames: [] },
            { header: '발신프로필', childNames: [] },
            { header: '마지막 수정일', childNames: [] },
          ],
        ],

        columns: [
          { name: 'no', header: 'No', align: 'center', width: '4%' },
          { name: 'custNm', header: '고객사명', align: 'center', width: '12%' },
          { name: 'bregNo', header: '사업자번호', align: 'center', width: '10%' },
          { name: 'tmpltCd', header: '템플릿코드', align: 'center', width: '12%' },
          { name: 'tmpltNm', header: '템플릿명', align: 'center', width: '18%' },
          { name: 'tmpltType', header: '템플릿 유형', align: 'center', width: '8%' },
          { name: 'stat', header: '상태', align: 'center', width: '8%' },
          { name: 'sendProfile', header: '발신프로필', align: 'center', width: '18%' },
          { name: 'lastChgDt', header: '마지막 수정일', width: '10%', cls: 'td_line' },
        ],
        noDataStr: '검색 결과가 없습니다.',
        params: {
          searchType1: '',
          searchType2: 'custNm',
          searchText1: '',
        },
        excelHeader: [],
      },
    };
  },
  components: {
    customGrid: customGrid,
    channelMgtApi,
    commonModal,
  },
  created() {
    this.getExcelHeader();
    this.setCodeData();
  },
  destroyed() {
    this.$store.commit('searchcondition/updateSearchCondition', {
      page: 1,
      perPage: 50,
      params: {
        searchType1: '',
        searchType2: 'custNm',
        searchText1: '',
      },
    });
  },
  mounted() {
    let page = 1;
    // 페이지 정보 및 검색 조건
    const getCondition = this.$store.getters['searchcondition/getSearchCondition'];

    // store에 저장된 페이지 정보 및 검색 조건을 불러오기
    let isKeep = false;
    if (getCondition) {
      this.grid.pagePerRows = getCondition.perPage;
      this.grid.params = getCondition.params;
      page = getCondition.page;
      isKeep = true;
    }
    this.search(isKeep);
  },
  methods: {
    search: function (isKeep) {
      this.grid.params.searchType1 = this.searchType1;
      this.grid.params.searchType2 = this.searchType2;
      this.grid.params.pagePerRows = this.perPageCnt;
      this.grid.perPage = this.perPageCnt;

      this.$refs.table.search(this.grid.params, isKeep);
      this.sendStoreData();
    },
    sendStoreData: function () {
      const getP = this.$refs.table.getPagination();
      this.$store.commit('searchcondition/updateSearchCondition', {
        page: getP._currentPage,
        perPage: this.perPageCnt,
        params: this.grid.params,
      });
    },
    async getExcelDataDown() {
      try {
        let response;
        const params = {
          searchType1: this.grid.params.searchType1,
          searchType2: this.grid.params.searchType2,
          searchText1: this.grid.params.searchText1,
        };

        response = await channelMgtApi.tmpltListExcel(params);

        const result = response.data;
        // entity code 변환
        result.data.list = result.data.list.map((item) => {
          return {
            ...item,
            custNm: this.fromHtmlEntities(item.custNm),
          };
        });
        if (result != null && result.retCode == '0000') {
          return result.data;
        } else {
          return false;
        }
      } catch (err) {
        return false;
      }
    }, // end of getExcelDataDown
    async excelDown() {
      if (this.$refs.table.getData().length <= 0) {
        this.row.title = '채널관리';
        this.row.msg1 = '조회된 데이터가 없습니다.';
        this.$refs.commmonModal.alertModalOpen(this.row);
        return false;
      }

      let today = moment().format('YYYYMMDDHHmmss');
      const saveFileName = `알림톡템플릿목록_${today}.xls`;

      const data = await this.getExcelDataDown();
      let options = {
        header: this.excelHeader,
        dataOrder: 'header',
      };
      xlsx.export(data.list, saveFileName, options).then(() => {});
    },
    getExcelHeader() {
      // 헤더를 mockup으로 관리한다.
      channelMgtApi.getExcelHeader(this.pageType).then((res) => {
        this.excelHeader = res;
      });
    },
    setCodeData() {
      // 상태 옵션 셋팅.
      api.commCode({ grpCd: 'TMPLT_STTUS_CD' }).then((response) => {
        this.statType = response.data.data.list;
      });
    },
    changePerPage: function () {
      // 페이지당 조회할 개수
      this.grid.pagePerRows = this.perPageCnt;
      this.search(true);
    },
    fromHtmlEntities(str) {
      return (str + '').replace(/&#\d+;/gm, function (s) {
        return String.fromCharCode(s.match(/\d+/gm)[0]);
      });
    },
  },

  beforeRouteLeave(to, from, next) {
    const getP = this.$refs.table.getPagination();
    this.$store.commit('searchcondition/updateSearchCondition', {
      page: getP._currentPage,
      perPage: this.perPageCnt,
      params: this.grid.params,
    });
    // 라우트 하기전 실행
    next();
  },
};
</script>
